<div id="user-listing" class="page-layout simple fullwidth">
  <app-header-page [smallTitleHeader]="'Users'" [titleHeader]="'User Listing'"></app-header-page>

  <div class="content p-24">

    <div class="mat-elevation-z8">
      <div class="scroll-table">

        <table mat-table [dataSource]="dataSource">

          <ng-container matColumnDef="action">
            <th mat-header-cell *matHeaderCellDef>
              <div class="action-th">
                Action
                <button (click)="openDialog()" mat-raised-button color="accent" class="margin-add-btn">
                  <mat-icon>add</mat-icon>
                </button>
              </div>
            </th>
            <td mat-cell class="text-center" *matCellDef="let row">
              <div class="action-column">
                <button mat-icon-button color="accent">
                  <mat-icon>edit</mat-icon>
                </button>
                <button mat-icon-button color="warn">
                  <mat-icon>delete</mat-icon>
                </button>
              </div>
            </td>
          </ng-container>

          <ng-container matColumnDef="select">
            <th mat-header-cell *matHeaderCellDef class="checkbox-center">
              <mat-checkbox (change)="$event ? masterToggle() : null"
                            [checked]="selection.hasValue() && isAllSelected()"
                            [indeterminate]="selection.hasValue() && !isAllSelected()">
              </mat-checkbox>
            </th>
            <td mat-cell *matCellDef="let row" class="text-center">
              <mat-checkbox (click)="$event.stopPropagation()"
                            (change)="$event ? selection.toggle(row) : null"
                            [checked]="selection.isSelected(row)">
              </mat-checkbox>
            </td>
          </ng-container>

          <ng-container matColumnDef="accounts">
            <th mat-header-cell *matHeaderCellDef>
              <div class="header-row-custom">
                Accounts
                <mat-form-field appearance="outline" class="filter" floatLabel="never">
                  <input matInput placeholder="Accounts" [formControl]="accountsFilter">
                </mat-form-field>
              </div>
            </th>
            <td mat-cell *matCellDef="let element"> {{ index }} </td>
          </ng-container>

          <ng-container matColumnDef="email">
            <th mat-header-cell *matHeaderCellDef>
              <div class="header-row-custom">
                Email
                <mat-form-field appearance="outline" class="filter" floatLabel="never">
                  <input matInput placeholder="Email" [formControl]="emailFilter">
                </mat-form-field>
              </div>
            </th>
            <td mat-cell *matCellDef="let element"> {{element.email}} </td>
          </ng-container>

          <ng-container matColumnDef="created">
            <th mat-header-cell *matHeaderCellDef>
              <div class="header-row-custom">
                Created
                <mat-form-field appearance="outline" class="filter" floatLabel="never">
                  <input matInput placeholder="Created" [formControl]="createdFilter">
                </mat-form-field>
              </div>
            </th>
            <td mat-cell *matCellDef="let element"> {{element.created}} </td>
          </ng-container>

          <ng-container matColumnDef="firstName">
            <th nowrap mat-header-cell *matHeaderCellDef>
              <div class="header-row-custom">
                First Name
                <mat-form-field appearance="outline" class="filter" floatLabel="never">
                  <input matInput placeholder="First Name" [formControl]="firstNameFilter">
                </mat-form-field>
              </div>
            </th>
            <td mat-cell *matCellDef="let element"> {{element.firstName}} </td>
          </ng-container>

          <ng-container matColumnDef="lastName">
            <th nowrap mat-header-cell *matHeaderCellDef>
              <div class="header-row-custom">
                Last Name
                <mat-form-field appearance="outline" class="filter" floatLabel="never">
                  <input matInput placeholder="Last Name" [formControl]="lastNameFilter">
                </mat-form-field>
              </div>
            </th>
            <td mat-cell *matCellDef="let element"> {{element.lastName}} </td>
          </ng-container>

          <ng-container matColumnDef="telephonePrimary">
            <th nowrap mat-header-cell *matHeaderCellDef>
              <div class="header-row-custom">
                Telephone Primary
                <mat-form-field appearance="outline" class="filter" floatLabel="never">
                  <input matInput placeholder="Telephone Primary" [formControl]="telephonePrimaryFilter">
                </mat-form-field>
              </div>
            </th>
            <td mat-cell *matCellDef="let element"> {{element.telephonePrimary}} </td>
          </ng-container>

          <ng-container matColumnDef="addressCountry">
            <th nowrap mat-header-cell *matHeaderCellDef>
              <div class="header-row-custom">
                Address Country
                <mat-form-field appearance="outline" class="filter" floatLabel="never">
                  <input matInput placeholder="Address Country" [formControl]="addressCountryFilter">
                </mat-form-field>
              </div>
            </th>
            <td mat-cell *matCellDef="let element"> {{element.addressCountry}} </td>
          </ng-container>

          <ng-container matColumnDef="lastLogin">
            <th nowrap mat-header-cell *matHeaderCellDef>
              <div class="header-row-custom">
                Last Login
                <mat-form-field appearance="outline" class="filter" floatLabel="never">
                  <input matInput placeholder="Last Login" [formControl]="lastLoginFilter">
                </mat-form-field>
              </div>
            </th>
            <td mat-cell *matCellDef="let element"> {{element.lastLogin}} </td>
          </ng-container>

          <ng-container matColumnDef="enabled">
            <th mat-header-cell class="border-col-end" *matHeaderCellDef>
              <div class="header-row-custom">
                Enabled
              </div>
            </th>
            <td mat-cell class="pt-4 text-center" *matCellDef="let element">
              <mat-icon color="accent" *ngIf="element.enabled">check_circle</mat-icon>
              <mat-icon color="warn" *ngIf="!element.enabled">cancel</mat-icon>
            </td>
          </ng-container>

          <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
          <tr mat-row *matRowDef="let row; columns: displayedColumns;" class="custom-row"></tr>
        </table>
      </div>

      <mat-paginator [pageSizeOptions]="[10, 20, 50]" showFirstLastButtons></mat-paginator>
    </div>

  </div>
</div>